#include "DxLib.h"
#include <math.h>

#define DRAW_NUM	(3)
#define SPACE		(512.0f)

int WINAPI WinMain( HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow )
{
	int ModelHandle ;
	int PixelShaderHandle ;
	int VertexShaderHandle ;
	float LightRotateAngle ;
	int SpotLightHandle ;
	int PointLightHandle ;
	int i, j ;
	float DrawX, DrawZ ;

	// EChE[hŋN
	ChangeWindowMode( TRUE ) ;

	// cwCȕ
	if( DxLib_Init() < 0 )
	{
		// G[璼ɏI
		return -1 ;
	}

	// _VF[_[ǂݍ
	VertexShaderHandle = LoadVertexShader( "NormalMesh_SpotPointLightVS.vso" ) ;

	// sNZVF[_[ǂݍ
	PixelShaderHandle = LoadPixelShader( "NormalMesh_SpotPointLightPS.pso" ) ;

	// ̃bVfǂݍ
	ModelHandle = MV1LoadModel( "NormalBox.mqo" ) ;

	// `𗠉ʂɂ
	SetDrawScreen( DX_SCREEN_BACK ) ;

	// f̕`ɃIWiVF[_[gpݒnmɂ
	MV1SetUseOrigShader( TRUE ) ;

	// gp钸_VF[_[Zbg
	SetUseVertexShader( VertexShaderHandle ) ;

	// gpsNZVF[_[Zbg
	SetUsePixelShader( PixelShaderHandle ) ;

	// ώ@₷ʒuɃJړ
	SetCameraPositionAndTarget_UpVecY( VGet( 800.0f, 400.0f, -800.0f ), VGet( 0.0f, 0.0f, 0.0f ) ) ;

	// Cg̈ʒu]l
	LightRotateAngle = 0.0f ;

	// WCg𖳌ɂ
	SetLightEnable( FALSE ) ;

	// X|bgCg쐬
	SpotLightHandle = CreateSpotLightHandle( VGet( 0.0f, 0.0f, 0.0f ), VGet( 0.0f, -1.0f, 0.0f ), 0.7f, 0.6f, 1000.0f, 0.391586f, 0.001662f, 0.0f ) ;

	// X|bgCg̃ArGgJ[𖳌ɂ
	SetLightAmbColorHandle( SpotLightHandle, GetColorF( 0.0f, 0.0f, 0.0f, 0.0f ) ) ;

	// X|bgCg̃fBt[YJ[΂ɂ
	SetLightDifColorHandle( SpotLightHandle, GetColorF( 0.0f, 1.0f, 0.0f, 0.0f ) ) ;

	// |CgCg쐬
	PointLightHandle = CreatePointLightHandle( VGet( 0.0f, 0.0f, 0.0f ), 7000.0f, 1.016523f, 0.000100f, 0.000010f ) ;

	// |CgCg̃ArGgJ[𖳌ɂ
	SetLightAmbColorHandle( PointLightHandle, GetColorF( 0.0f, 0.0f, 0.0f, 0.0f ) ) ;

	// |CgCg̃fBt[YJ[ԐFɂ
	SetLightDifColorHandle( PointLightHandle, GetColorF( 2.0f, 0.0f, 0.0f, 0.0f ) ) ;

	// O[oArGgCg(  )QO̖邳ɂ
	SetGlobalAmbientLight( GetColorF( 0.2f, 0.2f, 0.2f, 0.0f ) ) ;

	// ESCL[܂Ń[v
	while( ProcessMessage() == 0 && CheckHitKey( KEY_INPUT_ESCAPE ) == 0 )
	{
		// ʂ
		ClearDrawScreen() ;

		// Cg̈ʒủ]lZ
		LightRotateAngle += 0.02f ;

		// |CgCg̈ʒu̍XV
		SetLightPositionHandle( PointLightHandle, VGet( sin( LightRotateAngle ) * 500.0f, 400.0f, cos( LightRotateAngle ) * 500.0f ) ) ;

		// X|bgCg̈ʒu̍XV
		SetLightPositionHandle( SpotLightHandle, VGet( sin( -LightRotateAngle ) * 500.0f, 800.0f, cos( -LightRotateAngle ) * 500.0f ) ) ;

		// f`
		DrawZ = - ( DRAW_NUM - 1 ) * SPACE / 2.0f ;
		for( i = 0 ; i < DRAW_NUM ; i ++ )
		{
			DrawX = - ( DRAW_NUM - 1 ) * SPACE / 2.0f ;
			for( j = 0 ; j < DRAW_NUM ; j ++ )
			{
				// ʒuݒ
				MV1SetPosition( ModelHandle, VGet( DrawX, 0.0f, DrawZ ) ) ;

				// `
				MV1DrawModel( ModelHandle ) ;

				DrawX += SPACE ;
			}
			DrawZ += SPACE ;
		}

		// ʂ̓e\ʂɔf
		ScreenFlip() ;
	}

	// X|bgCg̍폜
	DeleteLightHandle( SpotLightHandle ) ;

	// |CgCg̍폜
	DeleteLightHandle( PointLightHandle ) ;

	// ǂݍ񂾒_VF[_[̍폜
	DeleteShader( VertexShaderHandle ) ;

	// ǂݍ񂾃sNZVF[_[̍폜
	DeleteShader( PixelShaderHandle ) ;

	// ǂݍ񂾃f̍폜
	MV1DeleteModel( ModelHandle ) ;

	// cwCǔn
	DxLib_End() ;

	// \tg̏I
	return 0 ;
}
